$   pid = f$getjpi("","PID")
$   set process/name="CGI_''pid'"
$!
$   on warning then goto done
$   crlf = F$FAO("!/")
$   thisfile = f$environment("procedure")
$   curdir = f$parse(thisfile,,,"device")+f$parse(thisfile,,,"directory")
$   jump = "$''curdir'jump.exe"
$   USEREXEC_SYMBOLS = "$WWW_ROOT:[BIN]USEREXEC_SYMBOLS.EXE"
$!
$   method = p1
$   url = p2
$   protocol = p3
$!
$   username = f$element(3,"/",url)
$   i = 4
$   script_path = ""
$   pathLoop:
$     script_name = f$element(i,"/",url)
$     if script_name .eqs. "/" then call send_sts "404 Invalid path" -
        "no CGI program name found."
$     if script_name .eqs. "-" then call send_sts "404 Invalid path" -
        "hyphens are not allowed in CGI program paths."
$     if f$locate(".",script_name) .ne. f$length(script_name) then goto pathLoopEnd
$     script_path = script_path + "." + script_name
$     i = i + 1
$   goto pathLoop
$   pathLoopEnd:
$!
$   if f$extract(0,1,username) .nes. "~" then call send_sts "404 Invalid username ''username'" -
       "URL should be in the form http://''www_http_host'/cgi/~username/cgi_script/params..."
$   username = username - "~"
$   jump 'username'
$!
$   define/nolog sys$output net_link
$   WRITE NET_LINK "<DNETRECMODE>"
$   tmpfile = "sys$scratch:cgi''pid'.tmp"
$!    USEREXEC_SYMBOLS creates it's logical names in the WWW_VARIABLES 
$!    logical name table.  We need to create it first.
$   create/name_table/parent=lnm$process_directory www_variables
$   define/nolog/table=lnm$directories lnm$file_dev www_variables,lnm$process,lnm$job,lnm$group,lnm$system,decw$logical_names
$   USEREXEC_SYMBOLS "WWW_" "FORM_" "''tmpfile'"
$   define/table=www_variables user 'username'   ! C loses the USER env variable after JUMP - I don't know why.
$!
$   if f$type(www_query_string) .nes. ""             ! append query string to end of the url field so GET forms will work
$   then
$     url = f$extract(0,200,url + "?" + www_query_string)
$   endif
$!
$!   Uncomment these to test the code.
$!
$!   write sys$output "content-type: text/html"
$!   write sys$output ""
$!   write sys$output "<pre>"
$!   set verify
$!
$   script_exec = "$" + f$search(f$parse("[.www.cgi"+script_path+"]"+script_name,".com"))
$   if script_exec .eqs. "$" then script_exec = "$" + -
        f$element(0,";",f$search(f$parse("[.www.cgi"+script_path+"]"+script_name,".exe")))
$   stype = f$parse(script_exec-"$",,,"TYPE")
$   if stype .eqs. ".COM"
$   then
$     script_exec[0,1] := "@"
$   endif
$!     
$   define/nolog form_input tmpfile
$   if ( script_exec .nes. "$" )
$   then
$     on warning then goto done
$     if stype .eqs. ".PL" .or. stype .eqs. ".CGI"
$     then
$       PERL == "$perl_root:[000000]perl.exe"
$       perl 'f$extract(1,255,script_exec)' "''method'" "''url'" "''protocol'" >net_link <'tmpfile'
$     else
$       define/user/nolog sys$input 'tmpfile'
$       script_exec "''method'" "''url'" "''protocol'"
$     endif
$   else
$      call send_sts "404 script not found" -
          "''f$fao("Requested script not found: !AS",script_name)'"
$   endif
$   goto done
$!
$done:
$   set noon
$   delete 'tmpfile';*
$   define/nolog/table=lnm$directories lnm$file_dev lnm$process,lnm$job,lnm$group,lnm$system,decw$logical_names
$   deassign/table=lnm$process_directory www_variables
$   jump             ! return to original username and call USEREXEC_CLEANUP.COM
$   WRITE NET_LINK "</DNETCGI>"   ! This should never get here.  But just incase...
$   exit
$!
$!
$send_sts: SUBROUTINE
$   set noon
$   write net_link "Content-Type: text/html",crlf
$   write net_link "<PRE>"
$   write net_link P1
$   write net_link P2
$   write net_link "</PRE>"
$   stop/id=0
$   exit
$ENDSUBROUTINE
